"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = featureComponents;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var React = _interopRequireWildcard(require("react"));

var _reactIs = require("react-is");

var _lodash = require("lodash");

var _reactRedux = require("react-redux");

var _reselect = require("reselect");

function featureComponents(options) {
  var _defaults = (0, _lodash.defaults)({}, options, {
    getFeatures: function getFeatures(state) {
      return state ? state.features : {};
    },
    sortFeatures: function sortFeatures(features) {
      return Object.values(features);
    }
  }),
      getFeatures = _defaults.getFeatures,
      sortFeatures = _defaults.sortFeatures,
      getComponents = _defaults.getComponents;

  var mapStateToProps = (0, _reselect.createStructuredSelector)({
    features: (0, _reselect.createSelector)(getFeatures, sortFeatures)
  });

  function mergeProps(_ref2, dispatchProps, _ref) {
    var features = _ref2.features;
    var children = _ref.children,
        props = (0, _objectWithoutProperties2.default)(_ref, ["children"]);
    var renderedComponents = [];
    features.forEach(function (feature, featureIndex) {
      var components = getComponents(feature);
      if (components == null) return;
      if (!Array.isArray(components)) components = [components];
      components.forEach(function (Comp, index) {
        var key = featureIndex + ':' + index;

        if (React.isValidElement(Comp)) {
          renderedComponents.push(React.cloneElement(Comp, (0, _objectSpread2.default)({}, props, {
            key: key
          })));
        } else if ((0, _reactIs.isValidElementType)(Comp)) {
          var FeatureComponent = Comp;
          renderedComponents.push(React.createElement(FeatureComponent, (0, _extends2.default)({}, props, {
            key: key
          })));
        }
      });
    });
    return {
      children: children instanceof Function ? children(renderedComponents) : React.createElement(React.Fragment, null, renderedComponents)
    };
  }

  var FeatureComponents = function FeatureComponents(_ref3) {
    var children = _ref3.children;
    return children;
  };

  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureComponents);
}